import java.io.*;
import java.util.*;
import java.lang.Math;

class BioComponents extends Useful {

 //SYSTEM LEVEL PARAMETERS
  //default, not recommend to be changed by program.
  long CurrentTime=System.currentTimeMillis(); 
  int AgeFilePrefixListNumber=0;
  String AgeFilePrefixList[];
  String AgeFilePrefix = new String("age/age");
  int TerminalGroupedFileIndex = 0;
  int AgePreBorn = -3, AgeBorn = -2, AgeYouth = 50, AgeAdult = 100, AgeOld = 200, AgeDie = 300, AgeEternal = 400;
  int CellLimit = 60, TerminalLimit = 200;
  int SilkLimit = 900;
  int ChainLimit=1, ChainSilkLimit=1;
  int BinNumberLimit = 40;  //this is the maximum value of BinXNumber and BinYNumber.
  int PerimeterBinNumberLimit = 100;
  int WirePitchDefault = 600;
  int SteinerArea = WirePitchDefault * WirePitchDefault;
  int TerminalWidthDefault = 2*WirePitchDefault;
  int PadWidthDefault = 1*WirePitchDefault;
  int PadSpacing = PadWidthDefault/2;
  //configurable parameters
  int WirePitch=WirePitchDefault;
  int WireLayerNumber=2;
  int KeepOutThicknessConstant = WirePitch*2;
  int Brief=10;               //brief-ness of the write. 10-most brief, 0-most detail 
  char CompactText='f';
  double AspectRatioMaxRate=1.5, AspectRatioMinRate=0.67;
  
 //AGE
  int age = 0;
 //REPORT PARAMETER
  long ChipArea=0;
  long TotalWireLength=0;
 
 //DELAY SPECIFICATION
  double OhmPerMicron=0.2, PicoPerMicron=0.00002;
  double TimeConstantInNano=OhmPerMicron*PicoPerMicron*0.001;
 //WEIGHT BETWEEN DIFFERENT KINDS OF FORCES
  //WeightChainAttractForce+WeightSilkAttractForce+WeightRoutingFillingForce=1
  //WeightCellAttractForce+WeightCellFillingForce=1
  //WeightSteinerAttractForce+WeightRoutingFillingForce=1
  //TerminalForce=WeightChainAttractForce*TerminalChainAttractForce
  //             +WeightSilkAttractForce*TerminalSIlkSilkAttractForce
  //             +WeightRoutingFillingForce*TerminalFillingForce
  //CellForce=WeightCellAttractForce*CellAttractForce+WeightCellFillingForce*CellFillingForce
  //SteinerForce=WeightSteinerAttractForce*SteinerAttractForce+WeightRoutingFillingForce*SteinerFillingForce
  //
  //usually we fix WeightRoutingForce.
  double WeightChainAttractForce=0.0, WeightSilkAttractForce=0.9, WeightRoutingFillingForce=0.1;
  double WeightCellAttractForce=1.0, WeightCellFillingForce=0.0;
  double WeightSteinerAttractForce=0.9, WeightSteinerFillingForce=0.1;
 //MOVE LIMIT
  int CellMoveLimit=999999999, SteinerMoveLimit=999999999;
 //CELL RATIO
  double CellNewRatio=1.0;
 //MOVE OR ROTATE
  boolean DisplacementNotOrientation=true;
 //HALO
  int HaloWidth=WirePitch;
 //LOAD/DRIVER
  int TerminalLoadDefault=50000, TerminalDriverDefault=50000;  
 //COMPACTION
  int AcceptableOverlappingCellPairNumber=0;
  
 //LIFE
  int TrialNumber=1;
  int BisectionNumber=2;
  double StartingEnergy=1.0;
  int FailedChainNumber=0;
  double MaximumChainEnergy=0.0;

 //CELL
  int CellNumber;
  String CellName[];
  double CellRatio[];
  long CellArea[];
  double CellAspectRatioMax[], CellAspectRatioMin[];
  char CellType[];   //b-softBoundary, B-hardBoundary, c-softCell with soft-body term, d-softCell with soft-boundary term, C-hardCell
  int CellDelayRate[];            //a rough input to output delay rate (can be 1,2,..,8)
  int CellSize[][], CellSizeOriginal[][];
  int CellPosition[][];
  char CellOrientation[];  
  int CellKeepOutThickness[][];   //0-left, 1-bottom, 2-right, 3-top edge keepoutthickness
  int CellForce[][], CellAttractForce[][], CellFillingForce[][];
  int CellBinBound[][];           //[][4] the left,bottom,right,top bin overlapping the cell.
  double CellBinBoundMargin[][];  //[][4] the margin(%) of left-bottomX, left-bY, right-topX, r-tY
  double CellFlipXGain[], CellFlipYGain[], CellRotateNegGain[], CellRotatePosGain[], CellRotate180Gain[], CellTurnPosGain[], CellTurnNegGain[];
  int PerimeterBinNumber[];
  int PerimeterBinSize[];
  double PerimeterRatio[];
  double PerimeterBinDensity[][];
  double PerimeterBinFillingForce[][];
  int TerminalNumber[];
  double TerminalTerminalEnergyMatrix[][][];  //record all pair of terminal-to-terminal delay. 
 //TERMINAL
  String TerminalName[][];
  int TerminalWidth[][];
  char TerminalDirection[][];  //i-in, o-out, b-biDirectional, g-gnd, v-vdd, c-clock
  int TerminalOffset[][][], TerminalOffsetOriginal[][][];
  int TerminalPosition[][][];
  int Terminal1DForce[][], Terminal1DFillingForce[][];  //*for 1-D use only.
  int Terminal1DBinBound[][][];                       //*[][2] the left,right bin overlapping the cell.
  double Terminal1DBinBoundMargin[][][];              //*[][2] the margin(%) of left, right
  int TerminalDriver[][];
  int TerminalLoad[][];         
  int TerminalSilk[][];
  int TerminalSilkLength[][]; double TerminalSilkDirection[][][];
  int TerminalForce[][][];
  int TerminalSilkAttractForceValue[][];
  int TerminalChainAttractForceValue[][];
  int TerminalFillingForce[][][];
  int TerminalBin[][][];   //[][2] the bin [x,y] this terminal is in.
 //SILK
  int SilkNumber;
  String SilkName[];
  int SteinerPosition[][];
  int SteinerForce[][], SteinerAttractForce[][], SteinerFillingForce[][];
  int SteinerBin[][];
  int SilkBBox[][];   //[][4]  left,bottom,right,top 
  int SilkTerminalNumber[], SilkTerminalCell[][], SilkTerminalTerminal[][];  //dual-directional pointer
  int SteinerMoveLimitRadius[];
 //CHAIN, new!
  int ChainNumber;
  String ChainName[];
  double ChainWeight[];
  double ChainRequiredEnergy[], ChainEnergy[];
  int ChainSilkNumber[];
  int ChainSilkStartCell[][], ChainSilkStartTerminal[][], ChainSilkEndCell[][], ChainSilkEndTerminal[][];
  double ChainSilkContribution[][];
  double ChainSilkEnergy[][];
 //BIN
  int BinXNumber, BinYNumber;
  int BinSize;
  double BinCellDensity[][], BinSilkDensity[][];
  double BinCellFillingForce[][][], BinSilkFillingForce[][][];
 //temp bin probability table, for use in silk density computation
  double BinProbabilityTable[][], BinHorizontalEndEdgeProbabilityTable[][], BinVerticalEndEdgeProbabilityTable[][]; 
 //Construction
  BioComponents() {
   //SYSTEM LEVEL PARAMETERS
    AgeFilePrefixList = new String[100];
   //Initialize all components within their array limits.
   //CELL    --NOTE: the CellLimit-th cell is a temp cell that is temporarily used by any subroutine.
    CellNumber = 0;
    CellName = new String[CellLimit+1];
    CellRatio = new double[CellLimit+1];
    CellArea = new long[CellLimit+1];
    CellAspectRatioMax = new double[CellLimit+1]; CellAspectRatioMin = new double[CellLimit+1];
    CellDelayRate = new int[CellLimit+1];
    CellSize = new int[CellLimit+1][2]; CellSizeOriginal = new int[CellLimit+1][2];
    CellType = new char[CellLimit+1];
    CellPosition = new int[CellLimit+1][2];
    CellOrientation = new char[CellLimit+1];  
    CellKeepOutThickness = new int[CellLimit+1][4];
    CellForce = new int[CellLimit+1][2]; CellAttractForce = new int[CellLimit+1][2]; CellFillingForce = new int[CellLimit+1][2];
    CellBinBound = new int[CellLimit+1][4]; CellBinBoundMargin = new double[CellLimit+1][4];
    CellFlipXGain = new double[CellLimit+1]; CellFlipYGain = new double[CellLimit+1];
    CellRotateNegGain = new double[CellLimit+1]; CellRotatePosGain = new double[CellLimit+1];
    CellRotate180Gain = new double[CellLimit+1]; CellTurnPosGain = new double[CellLimit+1]; CellTurnNegGain = new double[CellLimit+1];
    PerimeterBinNumber = new int[CellLimit+1];
    PerimeterBinSize = new int[CellLimit+1];
    PerimeterRatio = new double[CellLimit+1];
    PerimeterBinDensity = new double[CellLimit+1][PerimeterBinNumberLimit+1];
    PerimeterBinFillingForce = new double[CellLimit+1][PerimeterBinNumberLimit+1];
    TerminalNumber = new int[CellLimit+1];
    //TerminalTerminalEnergyMatrix = new double[CellLimit+1][TerminalLimit][TerminalLimit];
    TerminalTerminalEnergyMatrix = new double[CellLimit+1][1][1];
    //TERMINAL
    TerminalName = new String[CellLimit+1][TerminalLimit];
    TerminalWidth = new int[CellLimit+1][TerminalLimit];
    TerminalDirection = new char[CellLimit+1][TerminalLimit];
    TerminalOffset = new int[CellLimit+1][TerminalLimit][2]; TerminalOffsetOriginal = new int[CellLimit+1][TerminalLimit][2];
    TerminalPosition = new int[CellLimit+1][TerminalLimit][2];
    Terminal1DForce = new int[CellLimit+1][TerminalLimit]; Terminal1DFillingForce = new int[CellLimit+1][TerminalLimit];
    Terminal1DBinBound = new int[CellLimit+1][TerminalLimit][2]; Terminal1DBinBoundMargin = new double[CellLimit+1][TerminalLimit][2];  //1-dimensional bin for pads
    TerminalDriver = new int[CellLimit+1][TerminalLimit];
    TerminalLoad = new int[CellLimit+1][TerminalLimit];  
    TerminalSilk = new int[CellLimit+1][TerminalLimit];
    TerminalSilkLength = new int[CellLimit+1][TerminalLimit]; TerminalSilkDirection = new double[CellLimit+1][TerminalLimit][2];
    TerminalForce = new int[CellLimit+1][TerminalLimit+1][2];
    TerminalSilkAttractForceValue = new int[CellLimit+1][TerminalLimit];
    TerminalChainAttractForceValue = new int[CellLimit+1][TerminalLimit]; 
    TerminalFillingForce = new int[CellLimit+1][TerminalLimit][2];
    TerminalBin = new int[CellLimit+1][TerminalLimit][2];   //two-dimensional density bin
   //SILK  
    SilkNumber = 0;
    SilkName = new String[SilkLimit];
    SteinerPosition = new int[SilkLimit][2];
    SteinerForce = new int[SilkLimit][2]; SteinerAttractForce = new int[SilkLimit][2]; SteinerFillingForce = new int[SilkLimit][2];
    SteinerBin=new int[SilkLimit][2];
    SilkBBox = new int[SilkLimit][4];
    SilkTerminalNumber = new int[SilkLimit];
    SilkTerminalCell = new int[SilkLimit][60]; SilkTerminalTerminal = new int[SilkLimit][60];  //build a dual-directional pointer between terminal and silk.
    SteinerMoveLimitRadius = new int[SilkLimit];
   //CHAIN
    ChainNumber = 0;
    ChainName = new String[ChainLimit+1];
    ChainWeight = new double[ChainLimit+1];
    ChainRequiredEnergy = new double[ChainLimit+1]; ChainEnergy = new double[ChainLimit+1];
    ChainSilkNumber = new int[ChainLimit+1];
    ChainSilkStartCell = new int[ChainLimit+1][ChainSilkLimit+1]; ChainSilkStartTerminal = new int[ChainLimit+1][ChainSilkLimit+1];
    ChainSilkEndCell = new int[ChainLimit+1][ChainSilkLimit+1]; ChainSilkEndTerminal = new int[ChainLimit+1][ChainSilkLimit+1];
    ChainSilkContribution = new double[ChainLimit+1][ChainSilkLimit+1];
    ChainSilkEnergy = new double[ChainLimit+1][ChainSilkLimit+1];
   //BIN
    BinXNumber=BinNumberLimit; BinYNumber=BinNumberLimit; BinSize=1000;
    BinCellDensity = new double[BinNumberLimit+1][BinNumberLimit+1];
    BinSilkDensity = new double[BinNumberLimit+1][BinNumberLimit+1];
    BinCellFillingForce = new double[BinNumberLimit+1][BinNumberLimit+1][2];
    BinSilkFillingForce = new double[BinNumberLimit+1][BinNumberLimit+1][2];
   //temp bin probability table, for use in silk density computation
    BinProbabilityTable=new double[BinNumberLimit+1][BinNumberLimit+1];   
    BinHorizontalEndEdgeProbabilityTable=new double[BinNumberLimit+1][BinNumberLimit+1];
    BinVerticalEndEdgeProbabilityTable=new double[BinNumberLimit+1][BinNumberLimit+1];
   //Finish Construction
    System.out.println("All Bio-Components Built Up!");
  }
 

/*******************************************************************************************************/
/*                                       AGE                                                           */
/*******************************************************************************************************/
  void Age(int agenew) { 
    age = agenew; 
    System.out.println("$ ============"); 
    System.out.println("$ age= " + age); 
  }
  void AgeGrow() { age ++; }
  //boolean AgeChild() { if (age < AgeYouth) return true; return false; }
  //boolean AgeJunior() { if ((age>=AgeYouth) & (age<AgeAdult)) return true; return false; }
  //boolean AgeMan() { if ((age>=AgeAdult) & (age<AgeOld)) return true; return false; }
  //boolean AgeSenior() { if ((age>=AgeOld) & (age<AgeDie)) return true; return false; }
  //boolean AgeDeath() { if (age >= AgeDie) return true; return false; }
  //boolean AgeImmortality() { if (age >= AgeEternal) return true; return false; }
  
/*******************************************************************************************************/
/*                                       BASIC FUNCTIONS                                               */
/*******************************************************************************************************/
  void BuildBinProbabilityTable() {
    BinProbabilityTable[1][1]=1.0;
    for (int by=1; by<BinNumberLimit; by++) {
      for (int bx=1; bx<BinNumberLimit; bx++) {
        BinProbabilityTable[bx+1][by]+=BinProbabilityTable[bx][by]/2;
        BinProbabilityTable[bx][by+1]+=BinProbabilityTable[bx][by]/2;
      }
    }
    for (int by=1; by<BinNumberLimit; by++) BinProbabilityTable[BinNumberLimit][by+1]+=BinProbabilityTable[BinNumberLimit][by]/2;
    for (int bx=1; bx<BinNumberLimit; bx++) BinProbabilityTable[bx+1][BinNumberLimit]+=BinProbabilityTable[bx][BinNumberLimit]/2;
    for (int by=1; by<=BinNumberLimit; by++) {
      double transferProbability[]; transferProbability=new double[BinNumberLimit+1];
      transferProbability[1]=0.0;
      for (int bx=1; bx<BinNumberLimit; bx++) transferProbability[bx+1]=transferProbability[bx]+BinProbabilityTable[bx][by]/2;
      for (int bx=1; bx<=BinNumberLimit; bx++) BinHorizontalEndEdgeProbabilityTable[bx][by]=BinProbabilityTable[bx][by]+transferProbability[bx];
    }
    for (int bx=1; bx<=BinNumberLimit; bx++) {
      double transferProbability[]; transferProbability=new double[BinNumberLimit+1];
      transferProbability[1]=0.0;
      for (int by=1; by<BinNumberLimit; by++) transferProbability[by+1]=transferProbability[by]+BinProbabilityTable[bx][by]/2;
      for (int by=1; by<=BinNumberLimit; by++) BinVerticalEndEdgeProbabilityTable[bx][by]=BinProbabilityTable[bx][by]+transferProbability[by];
    }
  }

  void InitializeCellPosition(int seed) {  //determine bed size,position, & spread terminals on bed edge.
    Random random = new Random(seed);
    //determine bed size
    long totalArea=0;
    for (int c=1; c<=CellNumber; c++) totalArea+=CellArea[c];
    double bedsize = java.lang.Math.sqrt(totalArea);
    CellSizeOriginal[0][0]=(int)(bedsize*1.1); CellSizeOriginal[0][1]=(int)(bedsize*1.1);
    CellSize[0][0]=(int)bedsize; CellSize[0][1]=(int)bedsize;
    //case II(a), spread terminals evenly.
    if (TerminalNumber[0]>0) {
      int quaterTermNum = TerminalNumber[0]/4;
      int remainTermNum = TerminalNumber[0]-quaterTermNum*4;
      int terminalSpacing;
      if (remainTermNum==0) terminalSpacing=CellSize[0][0]/(quaterTermNum+1);
      else terminalSpacing=CellSize[0][0]/(quaterTermNum+2);
      int L1=quaterTermNum, L2=quaterTermNum, L3=quaterTermNum, L4=quaterTermNum;
      switch(remainTermNum) {
        case 1: L1++; break;
        case 2: L1++; L2++; break;
        case 3: L1++; L2++; L3++; break;
        case 4: System.out.println("ERROR. Impossible."); Sleep();
      }
      for (int t=1; t<=L1; t++) {                      //bottom edge
        TerminalOffset[0][t][0]=t*terminalSpacing; TerminalOffset[0][t][1]=0;
      }
      for (int t=1; t<=L2; t++) {                      //right edge
        TerminalOffset[0][t+L1][0]=CellSize[0][0]; TerminalOffset[0][t+L1][1]=t*terminalSpacing;
      }
      for (int t=1; t<=L3; t++) {                      //top edge
        TerminalOffset[0][t+L1+L2][0]=CellSize[0][0]-t*terminalSpacing; TerminalOffset[0][t+L1+L2][1]=CellSize[0][1];
      }
      for (int t=1; t<=L4; t++) {                      //left edge
        TerminalOffset[0][t+L1+L2+L3][0]=0; TerminalOffset[0][t+L1+L2+L3][1]=CellSize[0][1]-t*terminalSpacing;
      }
    }
   //put all cells and steiner points in bed randomly.
    double bedsizeX = CellSize[0][0], bedsizeY = CellSize[0][1];
    CellPosition[0][0]=(int)(-bedsizeX/2); CellPosition[0][1]=(int)(-bedsizeY/2);
    for (int c=1; c<=CellNumber; c++) {
      CellPosition[c][0] = CellPosition[0][0] + (int)(bedsizeX*random.nextDouble()) - CellSize[c][0]/2;
      CellPosition[c][1] = CellPosition[0][1] + (int)(bedsizeY*random.nextDouble()) - CellSize[c][1]/2;
      //randomly decide cell orientation.
    }
    for (int s=1; s<=SilkNumber; s++) {
      SteinerPosition[s][0] = CellPosition[0][0] + (int)(bedsizeX*random.nextDouble());
      SteinerPosition[s][1] = CellPosition[0][1] + (int)(bedsizeY*random.nextDouble());
    }
    System.out.println("$ Initialized all cells position. Chip size=" + CellSize[0][0] + "/" + CellSize[0][1]
                        + " position=" + CellPosition[0][0] + "/" + CellPosition[0][1] );
  }

  void InitializeCellOrientation(int seed) {
    Random random = new Random(1);
    for (int c=1; c<=CellNumber; c++) {
      int ranOrien = (int)(random.nextDouble()*8);
      switch (ranOrien) {
        case 0: CellOrientation[c]='w'; break;
        case 1: CellOrientation[c]='e'; break;
        case 2: CellOrientation[c]='s'; break;
        case 3: CellOrientation[c]='n'; break;
        case 4: CellOrientation[c]='h'; break;
        case 5: CellOrientation[c]='v'; break;
        case 6: CellOrientation[c]='t'; break;
        case 7: CellOrientation[c]='r'; break;
        default: CellOrientation[c]='n'; break;
      }
    } 
  }
  
  void UpdateAllCells(double newratio) {
    for (int c=1; c<=CellNumber; c++) {
      CellRatio[c]=newratio; UpdateACell(c);
    }
  }
  
  void UpdateACell(int c) {
    double asp=(CellSize[c][0]<1000 | CellSize[c][1]<1000)?
           (((double)CellSizeOriginal[c][1])/((double)CellSizeOriginal[c][0])):(((double)CellSize[c][1])/((double)CellSize[c][0]));
    double newArea=CellArea[c]*CellRatio[c];
    int w=(int)(java.lang.Math.sqrt(newArea/asp)), h=(int)(java.lang.Math.sqrt(newArea*asp));
    double wRate=((double)w)/((double)CellSize[c][0]), hRate=((double)h)/((double)CellSize[c][1]);
    int oldCenterPositionX=CellPosition[c][0]+CellSize[c][0]/2, oldCenterPositionY=CellPosition[c][1]+CellSize[c][1]/2;
    switch (CellOrientation[c]) {
      case 'w': CellSize[c][0]=h; CellSize[c][1]=w;
                for (int t=1; t<=TerminalNumber[c]; t++) {
                  TerminalOffset[c][t][0]=h-(int)(hRate*TerminalOffset[c][t][1]); 
                  TerminalOffset[c][t][1]=(int)(wRate*TerminalOffset[c][t][0]);
                }
                break;
      case 's': CellSize[c][0]=w; CellSize[c][1]=h;
                for (int t=1; t<=TerminalNumber[c]; t++) {
                  TerminalOffset[c][t][0]=w-(int)(wRate*TerminalOffset[c][t][0]);
                  TerminalOffset[c][t][1]=h-(int)(hRate*TerminalOffset[c][t][1]);
                }
                break;
      case 'e': CellSize[c][0]=h; CellSize[c][1]=w;
                for (int t=1; t<=TerminalNumber[c]; t++) {
                  TerminalOffset[c][t][0]=(int)(hRate*TerminalOffset[c][t][1]);
                  TerminalOffset[c][t][1]=w-(int)(wRate*TerminalOffset[c][t][0]);
                }
                break;
      case 'n': CellSize[c][0]=w; CellSize[c][1]=h;
                for (int t=1; t<=TerminalNumber[c]; t++) {
                  TerminalOffset[c][t][0]=(int)(wRate*TerminalOffset[c][t][0]);
                  TerminalOffset[c][t][1]=(int)(hRate*TerminalOffset[c][t][1]);
                }
                break;
      case 'h': CellSize[c][0]=w; CellSize[c][1]=h;
                for (int t=1; t<=TerminalNumber[c]; t++) {
                  TerminalOffset[c][t][0]=w-(int)(wRate*TerminalOffset[c][t][0]);
                  TerminalOffset[c][t][1]=(int)(hRate*TerminalOffset[c][t][1]);
                }
                break;
      case 'v': CellSize[c][0]=w; CellSize[c][1]=h;
                for (int t=1; t<=TerminalNumber[c]; t++) {
                  TerminalOffset[c][t][0]=(int)(wRate*TerminalOffset[c][t][0]);
                  TerminalOffset[c][t][1]=h-(int)(hRate*TerminalOffset[c][t][1]);
                }
                break;
      case 'r': CellSize[c][0]=h; CellSize[c][1]=w;        //h of w
                for (int t=1; t<=TerminalNumber[c]; t++) {
                  TerminalOffset[c][t][0]=(int)(hRate*TerminalOffset[c][t][1]); 
                  TerminalOffset[c][t][1]=(int)(wRate*TerminalOffset[c][t][0]);
                }
                break;
      case 't': CellSize[c][0]=h; CellSize[c][1]=w;        //h of e
                for (int t=1; t<=TerminalNumber[c]; t++) {
                  TerminalOffset[c][t][0]=h-(int)(hRate*TerminalOffset[c][t][1]);
                  TerminalOffset[c][t][1]=w-(int)(wRate*TerminalOffset[c][t][0]);
                }
                break;
      default: System.out.println("ERROR. unrecognized cell orientation " + CellName[c] + " " + CellOrientation[c]);
               Sleep();
    }
    //adjust cell position
    CellPosition[c][0]=oldCenterPositionX-CellSize[c][0]/2; CellPosition[c][1]=oldCenterPositionY-CellSize[c][1]/2;
    //System.out.println("$  Cell " + CellName[c] + " Size " + CellSize[c][0] + "/" + CellSize[c][1]);
  }


  void Explode(double inFactor) {
    double factor;
    if (inFactor<=0.0) {   //if inFactor undefined(<=0.0), then determine it.
     //calculate total size real area
      long area=0;
      for (int c=1; c<=CellNumber; c++) area+=CellArea[c];
      factor=java.lang.Math.sqrt(((double)area)/(((double)CellSize[0][0])*((double)CellSize[0][1])));
    }
    else {
      factor=inFactor;
    }
    System.out.println("$ Explode " + factor);
   //derive the median of all cells
    int medianX=0, medianY=0;
    for (int c=1; c<=CellNumber; c++) {
      medianX+=CellPosition[c][0]+CellSize[c][0]/2;
      medianY+=CellPosition[c][1]+CellSize[c][1]/2;
    }
    medianX/=CellNumber; medianY/=CellNumber;
   //explode
    for (int c=1; c<=CellNumber; c++) {
      CellPosition[c][0]+=(int)((CellPosition[c][0]+CellSize[c][0]/2-medianX)*factor);
      CellPosition[c][1]+=(int)((CellPosition[c][1]+CellSize[c][1]/2-medianX)*factor);
    }
  }


/*******************************************************************************************************/
/*                                       READ IN AN ORG FILE AND UPDATE ALL ITERMS                     */
/*******************************************************************************************************/
  void Read(int age){  //here, age is local.
    try {
      boolean InAnnotation = false;
      int LineNumber = 0;
      char InputChar;
      String InputLine = new String();
      InputStream f = new FileInputStream(AgeFilePrefix + age + ".org");
      String[] LineField;
      LineField = new String[1000];
      CellNumber = -1;
      ChainNumber=0;
      SilkNumber=0;
      int CurrentSilk = 0;
      int CurrentChain = 0;
      for (int s=1; s<SilkLimit; s++) SilkTerminalNumber[s]=0;
      while (f.available() != 0) {
        InputChar = (char) f.read();
        if (InputChar != '\n') {
          InputLine = InputLine + InputChar;
        }
        else {
         // Start analyse this line
          LineNumber ++; // System.out.println(" read line " + LineNumber + " \n");
         // Field extraction
          StringTokenizer st = new StringTokenizer(InputLine, " \r\n\t");
          int Token = 0;
          while (st.hasMoreTokens()) {
            Token++;
            LineField[Token] = st.nextToken();
          }
          if (CompactText=='f') {  //verbose version
              //for (int l=1; l<= Token; l++) System.out.println(l + "=" + LineField[l] + ", ");
              if (Token == 0 | InAnnotation == true) {
                //a blank line, do nothing.
                if (Token > 0) { //in annotation area, searching for */
                  if (LineField[Token].equals("*/")) InAnnotation = false; //exiting annotation area
                }
              }
             // fill in corresponding data structure field         
              else if (LineField[1].equals("//")) {
              }
              else if (LineField[1].equals("/*")) {
                InAnnotation = true; //entering annotation area
              }
             //CELL
              else if (LineField[1].equals("cell")) {
                if (Token >= 2) {
                  CellNumber ++;
                  CellName[CellNumber] = LineField[2];
                  CellRatio[CellNumber] = 1.0;
                  CellDelayRate[CellNumber] = 1;        //default is the minimum delay rate
                  CellOrientation[CellNumber] = 'n';    //default is the normal orientation.
                  CellKeepOutThickness[CellNumber][0]=HaloWidth; CellKeepOutThickness[CellNumber][1]=HaloWidth;
                  CellKeepOutThickness[CellNumber][2]=HaloWidth; CellKeepOutThickness[CellNumber][3]=HaloWidth;
                  TerminalNumber[CellNumber] = 0;
                  System.out.println("    *READING CELL " + CellName[CellNumber]);
                }
                else {
                  System.out.println("Token Number Incompatible with Cell Description in Line " + LineNumber);
                }
              }
              else if (LineField[1].equals("type")) {    
                if (Token >= 2) CellType[CellNumber] = LineField[2].charAt(0);
              }    
              else if (LineField[1].equals("ratio")) {
                if (Token >= 2) 
                  CellRatio[CellNumber] = StringToDouble(LineField[2]);
                  //System.out.println("# CellRatio Read");
              }    
              else if (LineField[1].equals("orientation")) {
                if (Token >= 2) CellOrientation[CellNumber] = LineField[2].charAt(0);
              }    
              else if (LineField[1].equals("size")) {
                if (Token >= 3) {
                  CellSize[CellNumber][0] = StringToInt(LineField[2]);
                  CellSize[CellNumber][1] = StringToInt(LineField[3]);
                }
              }
              else if (LineField[1].equals("sizeoriginal")) {
                if (Token >= 3) {
                  CellSizeOriginal[CellNumber][0] = StringToInt(LineField[2]);
                  CellSizeOriginal[CellNumber][1] = StringToInt(LineField[3]);
                  CellArea[CellNumber]=((long)CellSizeOriginal[CellNumber][0])*((long)CellSizeOriginal[CellNumber][1]);
                  double aspOriginal=1.0;
                  if (CellSizeOriginal[CellNumber][0]>0 & CellSizeOriginal[CellNumber][1]>0)
                    aspOriginal=((double)CellSizeOriginal[CellNumber][1])/((double)CellSizeOriginal[CellNumber][0]);
                  CellAspectRatioMax[CellNumber]=aspOriginal*AspectRatioMaxRate;
                  CellAspectRatioMin[CellNumber]=aspOriginal*AspectRatioMinRate;
                }
              }
              else if (LineField[1].equals("position")) {
                if (Token >= 3) {
                  CellPosition[CellNumber][0] = StringToInt(LineField[2]);
                  CellPosition[CellNumber][1] = StringToInt(LineField[3]);
                }
              }
              else if (LineField[1].equals("keepoutthickness")) {
                if (Token >= 5) {
                  CellKeepOutThickness[CellNumber][0] = StringToInt(LineField[2]);
                  CellKeepOutThickness[CellNumber][1] = StringToInt(LineField[3]);
                  CellKeepOutThickness[CellNumber][2] = StringToInt(LineField[4]);
                  CellKeepOutThickness[CellNumber][3] = StringToInt(LineField[5]);
                }
              }
              else if (LineField[1].equals("force")) {
                if (Token >= 3) {
                  CellForce[CellNumber][0] = StringToInt(LineField[2]);
                  CellForce[CellNumber][1] = StringToInt(LineField[3]);
                  //System.out.println("# CellForce Read");
                }
              }
              else if (LineField[1].equals("attractforce")) {
                if (Token >= 3) {
                  CellAttractForce[CellNumber][0] = StringToInt(LineField[2]);
                  CellAttractForce[CellNumber][1] = StringToInt(LineField[3]);
                  //System.out.println("# CellAttractForce Read for " + CellName[CellNumber]);
                }
              }
              else if (LineField[1].equals("fillingforce")) {
                if (Token >= 3) {
                  CellFillingForce[CellNumber][0] = StringToInt(LineField[2]);
                  CellFillingForce[CellNumber][1] = StringToInt(LineField[3]);
                  //System.out.println("# CellFillingForce Read for " + CellName[CellNumber]);
                }
              }
              else if (LineField[1].equals("perimeterbinnumber")) {
                if (Token >= 2) {
                  PerimeterBinNumber[CellNumber] = StringToInt(LineField[2]);
                }
              }
             //TERMINAL
              else if (LineField[1].equals("terminal")) {
                if (Token >= 2) {
                  TerminalNumber[CellNumber] ++;
                  TerminalName[CellNumber][TerminalNumber[CellNumber]] = LineField[2];
                  TerminalWidth[CellNumber][TerminalNumber[CellNumber]] = TerminalWidthDefault;
                  TerminalDirection[CellNumber][TerminalNumber[CellNumber]]='i';
                  TerminalDriver[CellNumber][TerminalNumber[CellNumber]]=0;
                  TerminalLoad[CellNumber][TerminalNumber[CellNumber]]=0;
                }
                //System.out.println("    * READING TERMINAL " + TerminalName[CellNumber][TerminalNumber[CellNumber]]);
              }
              else if (LineField[1].equals("terminalwidth")) {
                if (Token >= 2) {
                  TerminalWidth[CellNumber][TerminalNumber[CellNumber]] = StringToInt(LineField[2]);
                }
              }
              else if (LineField[1].equals("terminaldirection")) {
                if (Token >= 2) {
                  TerminalDirection[CellNumber][TerminalNumber[CellNumber]] = LineField[2].charAt(0);
                }
              }
              else if (LineField[1].equals("terminaloffset")) {
                if (Token >= 3) {
                  TerminalOffset[CellNumber][TerminalNumber[CellNumber]][0] = StringToInt(LineField[2]);
                  TerminalOffset[CellNumber][TerminalNumber[CellNumber]][1] = StringToInt(LineField[3]);
                }
              }
              else if (LineField[1].equals("terminaloffsetoriginal")) {
                if (Token >= 3) {
                  TerminalOffsetOriginal[CellNumber][TerminalNumber[CellNumber]][0] = StringToInt(LineField[2]);
                  TerminalOffsetOriginal[CellNumber][TerminalNumber[CellNumber]][1] = StringToInt(LineField[3]);
                }
              }
              else if (LineField[1].equals("terminaldriver")) {
                if (Token >= 2) TerminalDriver[CellNumber][TerminalNumber[CellNumber]] = StringToInt(LineField[2]);
              }
              else if (LineField[1].equals("terminalload")) {
                if (Token >= 2) TerminalLoad[CellNumber][TerminalNumber[CellNumber]] = StringToInt(LineField[2]);
              }
              else if (LineField[1].equals("terminalsilk")) {
                if (Token >= 2) {
                  //searching for the SilkName to check if it's existing. If not, create a new silk
                  int silk=GetSilkIndex(LineField[2]);
                  if (silk==-1) {
                    SilkNumber++; 
                    silk=SilkNumber;
                    SilkName[silk]=LineField[2];  //create new silk
                    SilkTerminalNumber[silk]=0;   //clear silkterminalnumber for newly created silk.
                  }
                  //silk contains the silk index
                  TerminalSilk[CellNumber][TerminalNumber[CellNumber]]=silk; 
                  //now add dual-directional terminal-silk pointer-pair, the silk->terminal poiner.
                  SilkTerminalNumber[silk]++;
                  SilkTerminalCell[silk][SilkTerminalNumber[silk]]=CellNumber; 
                  SilkTerminalTerminal[silk][SilkTerminalNumber[silk]]=TerminalNumber[CellNumber];
                  //System.out.println("         * Terminal " + CellName[CellNumber] + "/" + TerminalName[CellNumber][TerminalNumber[CellNumber]] 
                  //                    + " connects silk " + SilkName[silk] + " silkIndex=" + silk + " silkTerminalNumber=" + SilkTerminalNumber[silk]);
                }
              }
              else if (LineField[1].equals("terminal1Dfillingforce")) {
                if (Token >= 2) {
                  Terminal1DFillingForce[CellNumber][TerminalNumber[CellNumber]] = StringToInt(LineField[2]);
                }
              }
              else if (LineField[1].equals("terminal1Dforce")) {
                if (Token >= 2) {
                  Terminal1DForce[CellNumber][TerminalNumber[CellNumber]] = StringToInt(LineField[2]);
                }
              }
              else if (LineField[1].equals("terminalterminalenergy")) {
                if (Token >= 4) {
                  int ti=GetTerminalIndex(CellNumber,LineField[2]), to=GetTerminalIndex(CellNumber,LineField[3]);
                  if (ti==-1) { System.out.println("# ERROR. i terminal not found in line " + LineNumber); Sleep(); }
                  if (to==-1) { System.out.println("# ERROR. o terminal not found in line " + LineNumber); Sleep(); }
                  //TerminalTerminalEnergyMatrix[CellNumber][ti][to]=StringToDouble(LineField[4]);
                }
              }
             //SILK
              else if (LineField[1].equals("silk")) {
                if (Token >= 2) { 
                  //check the index of the silk. It should already be generated.
                  CurrentSilk=GetSilkIndex(LineField[2]);
                  if (CurrentSilk==-1) { System.out.println("# ERROR. Silk not occur in any terminal in Line " + LineNumber); Sleep(); }
                  //check silk-tree validity
                  int inTerminalNumber=0, outTerminalNumber=0;
                  for (int e=1; e<=SilkTerminalNumber[CurrentSilk]; e++) {
                 	switch (TerminalDirection[SilkTerminalCell[CurrentSilk][e]][SilkTerminalTerminal[CurrentSilk][e]]) {
                 	  case 'i' : inTerminalNumber++; break;
                  	  case 'o' : outTerminalNumber++; break;
                  	  default  : System.out.println("# WARNING. Terminal " + CellName[SilkTerminalCell[CurrentSilk][e]] + "/" 
                  	             + TerminalName[SilkTerminalCell[CurrentSilk][e]][SilkTerminalTerminal[CurrentSilk][e]] 
                  	             + " is neither i nor o. In line " + LineNumber);
                  	             break;  //might be bi-directional.
                  	}
                  }
                  switch(SilkTerminalNumber[CurrentSilk]) {
                  	case 0: System.out.println("# ERROR. Zero terminal on silk " + SilkName[CurrentSilk] + " in line " + LineNumber); Sleep();
                  	case 1: System.out.println("# ERROR. One terminal on silk " + SilkName[CurrentSilk] + " in line " + LineNumber); Sleep();
                  	default: if (outTerminalNumber>1) System.out.println("# WARNING. More than one o terminal on silk " + SilkName[CurrentSilk] + " in line " + LineNumber);
                             if (outTerminalNumber==0) System.out.println("# WARNING. No o terminal on silk " + SilkName[CurrentSilk] + " in line " + LineNumber);
                             if ((outTerminalNumber+inTerminalNumber)!=SilkTerminalNumber[CurrentSilk]) 
                               System.out.println("# WARNING. Some terminal(s) not recognized on silk " + SilkName[CurrentSilk] + " in line " + LineNumber);
                             break;
                  }
                }
              }
              else if (LineField[1].equals("steinerposition")) {
                if (Token >= 3) { 
                  SteinerPosition[CurrentSilk][0] = StringToInt(LineField[2]);
                  SteinerPosition[CurrentSilk][1] = StringToInt(LineField[3]);
                }
              }
              else if (LineField[1].equals("steinerattractforce")) {
                if (Token >= 3) { 
                  SteinerAttractForce[CurrentSilk][0] = StringToInt(LineField[2]);
                  SteinerAttractForce[CurrentSilk][1] = StringToInt(LineField[3]);
                }
              }
             //CHAIN
              else if (LineField[1].equals("chain")) {
                if (Token >= 2) {
                  ChainNumber++;
                  ChainName[ChainNumber]=LineField[2]; 
                  ChainSilkNumber[ChainNumber]=0;
                  System.out.println("    *READING CHAIN " + ChainName[ChainNumber]);
                }
              }
              else if (LineField[1].equals("chainweight")) {
                if (Token >= 2) {
                  ChainWeight[ChainNumber]=StringToDouble(LineField[2]); 
                }
              }
              else if (LineField[1].equals("chainrequiredenergy")) {
                if (Token >= 2) {
                  ChainRequiredEnergy[ChainNumber]=StringToDouble(LineField[2]); 
                }
              }
              else if (LineField[1].equals("chainsilk")) {
                if (Token >= 5) {
                  ChainSilkNumber[ChainNumber]++;
                  //Chainsilk Start node
                  int c0=GetCellIndex(LineField[2]);
                  if (c0==-1) { System.out.println("ERROR in line" + LineNumber + ", wrong chainsilk start cell!"); Sleep(); }
                  int t0=GetTerminalIndex(c0,LineField[3]);
                  if (t0==-1) { System.out.println("ERROR in line" + LineNumber + ", wrong chainsilk start terminal!"); Sleep(); }
                  if (TerminalDirection[c0][t0]!='o') { System.out.println("ERROR in line" + LineNumber + ", wrong chainsilk start terminal direction!"); Sleep(); }
                  //Chainsilk End node
                  int c1=GetCellIndex(LineField[4]);
                  if (c1==-1) { System.out.println("ERROR in line" + LineNumber + ", wrong chainsilk end cell!"); Sleep(); }
                  int t1=GetTerminalIndex(c1,LineField[5]);
                  if (t1==-1) { System.out.println("ERROR in line" + LineNumber + ", wrong chainsilk end terminal!"); Sleep(); }
                  if (TerminalDirection[c1][t1]!='i') { System.out.println("ERROR in line" + LineNumber + ", wrong chainsilk end terminal direction!"); Sleep(); }
                  //annotation
                  int s=ChainSilkNumber[ChainNumber];
                  ChainSilkStartCell[ChainNumber][s]=c0; ChainSilkStartTerminal[ChainNumber][s]=t0;
                  ChainSilkEndCell[ChainNumber][s]=c1; ChainSilkEndTerminal[ChainNumber][s]=t1;
                }
                else {
                  System.out.println("ERROR in token number (<5) in line " + LineNumber); Sleep();       
                }   
              }
             //BIN
              else if (LineField[1].equals("binnumber")) {
                if (Token >= 3) {
                  BinXNumber = StringToInt(LineField[2]); BinYNumber = StringToInt(LineField[3]);
                }
              }
             //OTHER INFORMATION
             //WRONG INPUT LINE
              else {
                // System.out.println("Keywords unrecognizable in line " + LineNumber);
              }
          }
          else {   //compact version
              //for (int l=1; l<= Token; l++) System.out.println(l + "=" + LineField[l] + ", ");
              if (Token == 0 | InAnnotation == true) {
                //a blank line, do nothing.
                if (Token > 0) { //in annotation area, searching for */
                  if (LineField[Token].equals("*/")) InAnnotation = false; //exiting annotation area
                }
              }
             // fill in corresponding data structure field         
              else if (LineField[1].equals("//")) {
              }
              else if (LineField[1].equals("/*")) {
                InAnnotation = true; //entering annotation area
              }
             //CELL
              else if (LineField[1].equals("cell")) {
                if (Token >= 2) {
                  CellNumber ++;
                  CellName[CellNumber] = LineField[2];
                  CellType[CellNumber] = LineField[3].charAt(0);
                  CellRatio[CellNumber] = StringToDouble(LineField[4]);
                  CellOrientation[CellNumber] = LineField[5].charAt(0);
                  CellSize[CellNumber][0]= StringToInt(LineField[6]); CellSize[CellNumber][1]= StringToInt(LineField[7]);
                  CellSizeOriginal[CellNumber][0]= StringToInt(LineField[8]); CellSizeOriginal[CellNumber][1]= StringToInt(LineField[9]);
                  CellPosition[CellNumber][0]= StringToInt(LineField[10]); CellPosition[CellNumber][1]= StringToInt(LineField[11]);
                  TerminalNumber[CellNumber] = 0;
                  CellKeepOutThickness[CellNumber][0]=HaloWidth; CellKeepOutThickness[CellNumber][1]=HaloWidth;
                  CellKeepOutThickness[CellNumber][2]=HaloWidth; CellKeepOutThickness[CellNumber][3]=HaloWidth;
                  CellArea[CellNumber]=((long)CellSizeOriginal[CellNumber][0])*((long)CellSizeOriginal[CellNumber][1]);
                  double aspOriginal=1.0;
                  if (CellSizeOriginal[CellNumber][0]>0 & CellSizeOriginal[CellNumber][1]>0)
                    aspOriginal=((double)CellSizeOriginal[CellNumber][1])/((double)CellSizeOriginal[CellNumber][0]);
                  CellAspectRatioMax[CellNumber]=aspOriginal*AspectRatioMaxRate;
                  CellAspectRatioMin[CellNumber]=aspOriginal*AspectRatioMinRate;
                  System.out.println("    *READING CELL " + CellName[CellNumber]);
                }
                else {
                  System.out.println("Token Number Incompatible with Cell Description in Line " + LineNumber);
                }
              }
             //TERMINAL
              else if (LineField[1].equals("terminal")) {
                if (Token >= 2) {
                  TerminalNumber[CellNumber] ++;
                  TerminalName[CellNumber][TerminalNumber[CellNumber]] = LineField[2];
                  TerminalWidth[CellNumber][TerminalNumber[CellNumber]] = StringToInt(LineField[3]);
                  TerminalOffset[CellNumber][TerminalNumber[CellNumber]][0]= StringToInt(LineField[4]); 
                  TerminalOffset[CellNumber][TerminalNumber[CellNumber]][1]= StringToInt(LineField[5]);
                  TerminalOffsetOriginal[CellNumber][TerminalNumber[CellNumber]][0]= StringToInt(LineField[6]);
                  TerminalOffsetOriginal[CellNumber][TerminalNumber[CellNumber]][1]= StringToInt(LineField[7]);
                  TerminalDirection[CellNumber][TerminalNumber[CellNumber]]='i';
                  TerminalDriver[CellNumber][TerminalNumber[CellNumber]]=0;
                  TerminalLoad[CellNumber][TerminalNumber[CellNumber]]=0;
                  int silk=GetSilkIndex(LineField[8]);
                  if (silk==-1) {
                    SilkNumber++; 
                    silk=SilkNumber;
                    SilkName[silk]=LineField[8];  //create new silk
                    SilkTerminalNumber[silk]=0;   //clear silkterminalnumber for newly created silk.
                    //System.out.println("       Create silk " + SilkName[SilkNumber]);
                  }
                  //silk contains the silk index
                  TerminalSilk[CellNumber][TerminalNumber[CellNumber]]=silk; 
                  //now add dual-directional terminal-silk pointer-pair, the silk->terminal poiner.
                  SilkTerminalNumber[silk]++;
                  SilkTerminalCell[silk][SilkTerminalNumber[silk]]=CellNumber; 
                  SilkTerminalTerminal[silk][SilkTerminalNumber[silk]]=TerminalNumber[CellNumber];
                  //System.out.println("         * Terminal " + CellName[CellNumber] + "/" + TerminalName[CellNumber][TerminalNumber[CellNumber]] 
                  //                    + " connects silk " + SilkName[silk] + " silkIndex=" + silk + " silkTerminalNumber=" + SilkTerminalNumber[silk]);
                }
                //System.out.println("    * READING TERMINAL " + TerminalName[CellNumber][TerminalNumber[CellNumber]]);
              }
             //SILK
              else if (LineField[1].equals("silk")) {
                if (Token >= 2) { 
                  //check the index of the silk. It should already be generated.
                  CurrentSilk=GetSilkIndex(LineField[2]);
                  if (CurrentSilk==-1) { System.out.println("# ERROR. Silk " + LineField[2] + " not occur in any terminal in Line " + LineNumber); Sleep(); }
                  SteinerPosition[CurrentSilk][0]=StringToInt(LineField[3]); SteinerPosition[CurrentSilk][1]=StringToInt(LineField[4]);
                }
              }
             //BIN
              else if (LineField[1].equals("binnumber")) {
                if (Token >= 3) {
                  BinXNumber = StringToInt(LineField[2]); BinYNumber = StringToInt(LineField[3]);
                }
              }
             //OTHER INFORMATION
             //WRONG INPUT LINE
              else {
                // System.out.println("Keywords unrecognizable in line " + LineNumber);
              }
          }
          // Clear string InputLine for reception of a new line
          InputLine = " ";
        }
      }
      f.close();
      System.out.println("Finish Reading Age " + age + "!");
    }
    catch (FileNotFoundException e) {
      System.out.println("File not Found!");
    }
    catch (IOException e) {
      System.out.println("IO Exception Occurs!");
    }
    finally {
    }
  }  


/*******************************************************************************************************/
/*                                       WRITE AN ORG FILE WITH ALL ITERMS                             */
/*******************************************************************************************************/
  void Write() {
    try {
      String InputLine = new String();
      OutputStream f = new FileOutputStream(AgeFilePrefix + age + ".org");
      String LineField = new String();
     //SYSTEM PARAMETERS
      WriteALineToFile(("/* \r\n"), f);
      WriteALineToFile(("age " + age + "\r\n"), f);
      WriteALineToFile(("WeightChainAttractForce   " + WeightChainAttractForce + "\r\n"), f);
      WriteALineToFile(("WeightSilkAttractForce    " + WeightSilkAttractForce + "\r\n"), f);
      WriteALineToFile(("WeightRoutingFillingForce " + WeightRoutingFillingForce + "\r\n"), f);
      WriteALineToFile(("WeightCellAttractForce    " + WeightCellAttractForce + "\r\n"), f);
      WriteALineToFile(("WeightCellFillingForce    " + WeightCellFillingForce + "\r\n"), f);
      WriteALineToFile(("WeightSteinerAttractForce " + WeightSteinerAttractForce + "\r\n"), f);
      WriteALineToFile(("WeightSteinerFillingForce " + WeightSteinerFillingForce + "\r\n"), f);
      WriteALineToFile(("CellMoveLimit    " + CellMoveLimit + "\r\n"), f);
      WriteALineToFile(("SteinerMoveLimit " + SteinerMoveLimit + "\r\n"), f);
      WriteALineToFile(("BinNumber X/Y " + BinXNumber + "/" + BinYNumber + " BinSize " + BinSize + "\r\n"), f);
      WriteALineToFile(("*/ \r\n\r\n"), f);

      if (CompactText=='f') {  //verbose version text
         //CELL, TERMINAL
          for (int c = 0; c <= CellNumber; c ++) {
            WriteALineToFile(("cell " + CellName[c] + "\r\n"), f); 
            WriteALineToFile(("  type " + CellType[c] + "\r\n"), f);
            WriteALineToFile(("  ratio " + CellRatio[c] + "\r\n"), f);
            WriteALineToFile(("  orientation " + CellOrientation[c] + "\r\n"), f);
            WriteALineToFile(("  size " + CellSize[c][0] + " " + CellSize[c][1] + "\r\n"), f);
            WriteALineToFile(("  sizeoriginal " + CellSizeOriginal[c][0] + " " + CellSizeOriginal[c][1] + "\r\n"), f);
            WriteALineToFile(("  position " + CellPosition[c][0] + " " + CellPosition[c][1] + "\r\n"), f);
            if (Brief<=7) {
              WriteALineToFile(("  keepoutthickness " + CellKeepOutThickness[c][0] + " " + CellKeepOutThickness[c][1] + " "
                                                      + CellKeepOutThickness[c][2] + " " + CellKeepOutThickness[c][3] + "\r\n"), f); 
              WriteALineToFile(("  attractforce " + CellAttractForce[c][0] + " " + CellAttractForce[c][1] + "\r\n"), f);
              WriteALineToFile(("  fillingforce " + CellFillingForce[c][0] + " " + CellFillingForce[c][1] + "\r\n"), f);
              WriteALineToFile(("  force " + CellForce[c][0] + " " + CellForce[c][1] + "\r\n"), f);
            }
            if (Brief<=5) {
              WriteALineToFile(("  binbound " + CellBinBound[c][0] + " " + CellBinBound[c][1] + " "
                                              + CellBinBound[c][2] + " " + CellBinBound[c][3] + "\r\n"), f);
              WriteALineToFile(("  binboundmargin " + CellBinBoundMargin[c][0] + " " + CellBinBoundMargin[c][1] + " "
                                                    + CellBinBoundMargin[c][2] + " " + CellBinBoundMargin[c][3] + "\r\n"), f);
              if (CellType[c]=='C') WriteALineToFile(("  orientationgain " + CellFlipXGain[c] + " " + CellFlipYGain[c] + " "
                                              + CellRotateNegGain[c] + " " + CellRotatePosGain[c] + " "
                                              + CellRotate180Gain[c] + " " + CellTurnPosGain[c] + " " + CellTurnNegGain[c] + "\r\n"), f);
            }
            if (Brief<=9) {
              if (CellType[c]=='b' | CellType[c]=='d') { 
                WriteALineToFile(("  perimeterbinnumber " + PerimeterBinNumber[c] + "\r\n"), f);
                WriteALineToFile(("  perimeterbinsize " + PerimeterBinSize[c] + "\r\n"), f);
                WriteALineToFile(("  perimeterratio " + PerimeterRatio[c] + "\r\n"), f);
              }
              WriteALineToFile(("  /* \r\n"), f);
              for (int b=1; b<=PerimeterBinNumber[c]; b++) {
                WriteALineToFile(("    perimeterbindensity/fillingforce[" + b +"] " + PerimeterBinDensity[c][b] + "/" + PerimeterBinFillingForce[c][b] + "\r\n"), f);
              }
              WriteALineToFile(("  */ \r\n"), f);
            }
            for (int t = 1; t <= TerminalNumber[c]; t ++) {
              if (TerminalNumber[c] == 0) break;
              else {
                WriteALineToFile(("  terminal " + TerminalName[c][t] + "\r\n"), f);
                WriteALineToFile(("    terminaldirection " + TerminalDirection[c][t] + "\r\n"), f);
                WriteALineToFile(("    terminaloffset " + TerminalOffset[c][t][0] + " " + TerminalOffset[c][t][1] + "\r\n"), f);
                WriteALineToFile(("    terminaloffsetoriginal " + TerminalOffsetOriginal[c][t][0] + " " + TerminalOffsetOriginal[c][t][1] + "\r\n"), f);
                WriteALineToFile(("    terminalwidth " + TerminalWidth[c][t] + "\r\n"), f);
                if (TerminalDirection[c][t]=='o') 
                  WriteALineToFile(("    terminaldriver " + TerminalDriver[c][t] + "\r\n"), f);
                else if (TerminalDirection[c][t]=='i') 
                  WriteALineToFile(("    terminalload " + TerminalLoad[c][t] + "\r\n"), f);
                WriteALineToFile(("    terminalsilk " + SilkName[TerminalSilk[c][t]] + "\r\n"), f);
                if (Brief<=6) {
                  WriteALineToFile(("    terminalposition " + TerminalPosition[c][t][0] + " " + TerminalPosition[c][t][1] + "\r\n"), f);
                  WriteALineToFile(("    terminalsilklength " + TerminalSilkLength[c][t] + "\r\n"), f);
                  WriteALineToFile(("    terminalsilkdirection " + TerminalSilkDirection[c][t][0] + " " + TerminalSilkDirection[c][t][1] + "\r\n"), f);
                  WriteALineToFile(("    terminalforce " + TerminalForce[c][t][0] + " " + TerminalForce[c][t][1] + "\r\n"), f);
                  WriteALineToFile(("    terminalchainattractforcevalue " + TerminalChainAttractForceValue[c][t] + "\r\n"), f);
                  WriteALineToFile(("    terminalsilkattractforcevalue " + TerminalSilkAttractForceValue[c][t] + "\r\n"), f);
                  WriteALineToFile(("    terminalsilkfillingforce " + TerminalFillingForce[c][t][0] + " " + TerminalFillingForce[c][t][1] + "\r\n"), f);
                  WriteALineToFile(("    terminalbin " + TerminalBin[c][t][0] + " " + TerminalBin[c][t][1] + "\r\n"), f);
                }
                if (Brief<=3) {
                  if (c==0) {
                    WriteALineToFile(("    terminal1Dfillingforce " + Terminal1DFillingForce[c][t] + "\r\n"), f);
                    WriteALineToFile(("    terminal1Dforce " + Terminal1DForce[c][t] + "\r\n"), f);
                    WriteALineToFile(("    terminal1Dbinbound " + Terminal1DBinBound[c][t][0] + " " + Terminal1DBinBound[c][t][1] + "\r\n"), f);
                    WriteALineToFile(("    terminal1Dbinboundmargin " + Terminal1DBinBoundMargin[c][t][0] + " " + Terminal1DBinBoundMargin[c][t][1] + "\r\n"), f);
                  }
                }
              }
            }
            //for (int ti=1; ti<=TerminalNumber[c]; ti++) {
           	//  for (int to=1; to<=TerminalNumber[c]; to++) {
          	//    if (TerminalTerminalEnergyMatrix[c][ti][to]>0) 
          	//      WriteALineToFile(("  terminalterminalenergy " + TerminalName[c][ti] + " " + TerminalName[c][to] + " " + TerminalTerminalEnergyMatrix[c][ti][to] + "\r\n"), f);
          	//  }
            // }
          }
          WriteALineToFile("   \r\n", f);
         //SILK
          for (int s = 1; s <= SilkNumber; s ++) {
            WriteALineToFile(("silk " + SilkName[s] + "\r\n"), f);
            WriteALineToFile(("  steinerposition " + SteinerPosition[s][0] + " " + SteinerPosition[s][1] + "\r\n"), f);
            if (Brief<=7) {
              WriteALineToFile(("  steinerforce " + SteinerForce[s][0] + " " + SteinerForce[s][1] + "\r\n"), f);
              WriteALineToFile(("  steinerattractforce " + SteinerAttractForce[s][0] + " " + SteinerAttractForce[s][1] + "\r\n"), f);
              WriteALineToFile(("  steinerfillingforce " + SteinerFillingForce[s][0] + " " + SteinerFillingForce[s][1] + "\r\n"), f);
              WriteALineToFile(("  steinerbin " + SteinerBin[s][0] + " " + SteinerBin[s][1] + "\r\n"), f);
              if (SilkTerminalNumber[s]>0) {
                WriteALineToFile(("  silkterminal "), f);
                for (int n=1; n<=SilkTerminalNumber[s]; n++) {
                  int c=SilkTerminalCell[s][n], t=SilkTerminalTerminal[s][n];
                  WriteALineToFile((CellName[c] + " " + TerminalName[c][t] + " "), f);
                }
              }
              WriteALineToFile(("\r\n"), f);
            }
          }
          WriteALineToFile(("\r\n"), f);
         //CHAIN
          for (int n=1; n<=ChainNumber; n++) {
            WriteALineToFile(("chain " + ChainName[n] + "\r\n"), f);
            WriteALineToFile(("  chainrequiredenergy " + ChainRequiredEnergy[n] + "\r\n"), f);
            if (Brief<=9) {
              WriteALineToFile(("  chainenergy " + ChainEnergy[n] + "\r\n"), f);
              WriteALineToFile(("  chainweight " + ChainWeight[n] + "\r\n"), f);
            }
            for (int s=1; s<=ChainSilkNumber[n]; s++) {
              int c0=ChainSilkStartCell[n][s], t0=ChainSilkStartTerminal[n][s];
              int c1=ChainSilkEndCell[n][s], t1=ChainSilkEndTerminal[n][s];
              WriteALineToFile(("  chainsilk " + CellName[c0] + " " + TerminalName[c0][t0] + " "
                               + CellName[c1] + " " + TerminalName[c1][t1] + "\r\n"), f);
              if (Brief<=9) {
                WriteALineToFile(("    chainsilkcontribution " + ChainSilkContribution[n][s] + "\r\n"), f);
                WriteALineToFile(("    chainsilkenergy " + ChainSilkEnergy[n][s] + "\r\n"), f);
              }
            }
          }
          WriteALineToFile(("\r\n"), f);
          //BIN
          WriteALineToFile(("binnumber " + BinXNumber + " " + BinYNumber + "\r\n"), f);
          if (Brief<=2) {
            WriteALineToFile(("/* BinDensity of Cell and Silk, and FillingForce of Cell and Silk\r\n"), f);
            for (int bx=1; bx<=BinXNumber; bx++) {
              for (int by=1; by<=BinYNumber; by++) {
                WriteALineToFile(("[" + bx + "," + by + "] " 
                                 + BinCellDensity[bx][by] + " " + BinSilkDensity[bx][by]
                                 + " (" + ((int)BinCellFillingForce[bx][by][0]) + "," + ((int)BinCellFillingForce[bx][by][1]) 
                                 + ") (" + ((int)BinSilkFillingForce[bx][by][0]) + "," + ((int)BinSilkFillingForce[bx][by][1]) + ")\r\n"), f);
              }
            }
            WriteALineToFile(("*/ \r\n\r\n"), f);
          }
      }
      else { //compact version text    
          for (int c = 0; c <= CellNumber; c ++) {
            WriteALineToFile(("cell " + CellName[c] + " " + CellType[c] + " " + CellRatio[c] + " " + CellOrientation[c] + " "
                             + CellSize[c][0] + " " + CellSize[c][1] + " " + CellSizeOriginal[c][0] + " " + CellSizeOriginal[c][1] + " "
                             + CellPosition[c][0] + " " + CellPosition[c][1] + "\r\n"), f); 
            for (int t = 1; t <= TerminalNumber[c]; t ++) {
              if (TerminalNumber[c] == 0) break;
              else {
                WriteALineToFile(("  terminal " + TerminalName[c][t] + " " + TerminalWidth[c][t] + " "
                                 + TerminalOffset[c][t][0] + " " + TerminalOffset[c][t][1] + " "
                                 + TerminalOffsetOriginal[c][t][0] + " " + TerminalOffsetOriginal[c][t][1] + " "
                                 + SilkName[TerminalSilk[c][t]] + "\r\n"), f);
              }
            }
          }
          for (int s = 1; s <= SilkNumber; s ++) {
            WriteALineToFile(("silk " + SilkName[s] + " " + SteinerPosition[s][0] + " " + SteinerPosition[s][1] + "\r\n"), f);
          }
      }
      //OVER
      WriteALineToFile(("\r\n"), f);
      f.close();
    }
    catch (IOException e) {
      System.out.println("IO Exception Occurs!");
    }
    finally {
    }
      
  }


/*******************************************************************************************************/
/*                                       EDUCATE, READ IN MECHANICAL CONSTANTS                         */
/*******************************************************************************************************/
  void Educate(){
    try {
      int LineNumber = 0;
      char InputChar;
      String InputLine = new String();
      InputStream f = new FileInputStream("educate.org");
      String[] LineField;
      LineField = new String[16];
      while (f.available() != 0) {
        InputChar = (char) f.read();
        if (InputChar != '\n') {
          InputLine = InputLine + InputChar;
        }
        else {
         // Start analyse this line
          LineNumber ++;
         // Field extraction
          StringTokenizer st = new StringTokenizer(InputLine, " \r\n\t");
          int Token = 0;
          while (st.hasMoreTokens()) {
            Token++;
            LineField[Token] = st.nextToken();
          }
          if (Token == 0) {
            //a blank line, do nothing.
          }
         // fill in corresponding data structure field         
          else if (LineField[1].equals("//")) {
          }
          else if (LineField[1].equals("AgeFilePrefix")) {
            if (Token == 2) {
              AgeFilePrefixListNumber ++;
              AgeFilePrefixList[AgeFilePrefixListNumber]=LineField[2];
              AgeFilePrefix=AgeFilePrefixList[1];   //default. Pointing to the first read AgeFilePrefix
            }
          }
          else if (LineField[1].equals("AgePreBorn")) {
            if (Token == 2) AgePreBorn = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("AgeBorn")) {
            if (Token == 2) AgeBorn = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("AgeAdult")) {
            if (Token == 2) AgeAdult = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("AgeOld")) {
            if (Token == 2) AgeOld = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("AgeYouth")) {
            if (Token == 2) AgeYouth = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("AgeMax")) {
            if (Token == 2) AgeDie = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("AgeDie")) {
            if (Token == 2) AgeDie = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("AgeEternal")) {
            if (Token == 2) AgeEternal = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("OhmPerMicron")) {
            if (Token == 2) {
              OhmPerMicron = StringToDouble(LineField[2]);
              TimeConstantInNano=PicoPerMicron*OhmPerMicron;
            }
          }
          else if (LineField[1].equals("PicoPerMicron")) {
            if (Token == 2) { 
              PicoPerMicron = StringToDouble(LineField[2]);
              TimeConstantInNano=PicoPerMicron*OhmPerMicron;
            }
          }
          else if (LineField[1].equals("TerminalLoadCapacitanceInPicoDefault")) {
            if (Token == 2) { 
              TerminalLoadDefault = (int)((StringToDouble(LineField[2]))/PicoPerMicron*1000);
            }
          }
          else if (LineField[1].equals("TerminalDriverResistanceInOhmDefault")) {
            if (Token == 2) { 
              TerminalDriverDefault = (int)((StringToDouble(LineField[2]))/OhmPerMicron*1000);
            }
          }
          else if (LineField[1].equals("AcceptableOverlappingCellPairNumber")) {
            if (Token == 2) { 
              AcceptableOverlappingCellPairNumber = StringToInt(LineField[2]);
            }
          }
          else if (LineField[1].equals("Brief")) {
            if (Token == 2) Brief = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("CompactText")) {
            if (Token == 2) CompactText = LineField[2].charAt(0);
          }
          else if (LineField[1].equals("TrialNumber")) {
            if (Token == 2) TrialNumber = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("BisectionNumber")) {
            if (Token == 2) BisectionNumber = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("StartingEnergy")) {
            if (Token == 2) StartingEnergy = StringToDouble(LineField[2]);
          }
          else if (LineField[1].equals("WirePitch")) {
            if (Token == 2) WirePitch = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("WireLayerNumber")) {
            if (Token == 2) WireLayerNumber = StringToInt(LineField[2]);
          }
          else if (LineField[1].equals("AspectRatioMaxRate")) {
            if (Token == 2) AspectRatioMaxRate=StringToDouble(LineField[2]);
          }
          else if (LineField[1].equals("AspectRatioMinRate")) {
            if (Token == 2) AspectRatioMinRate=StringToDouble(LineField[2]);
          }
          else {
           // wrong input line
            System.out.println("Keywords Unknown in Line " + LineNumber + "!!"); Sleep();
          }
           // Clear string InputLine for reception of a new line
          InputLine = " ";
        }
      }
      f.close();
      System.out.println("Finish Reading educate.org!");
    }
    catch (FileNotFoundException e) {
      System.out.println("File educate.org not Found!");
    }
    catch (IOException e) {
      System.out.println("IO Exception Occurs in Reading educate.org!");
    }
    finally {
    }
  }  

  
/*******************************************************************************************************/
/*                                       SLEEP                                                         */
/*******************************************************************************************************/
  void Sleep() {  //actually SUICIDE
    for (;true;);
  }

/*******************************************************************************************************/
/*                                       STATISTIC                                                     */
/*******************************************************************************************************/
  void Statistic() {
    int maxSize=-999999, minSize=999999999; long sumSize=0;
    long maxArea=-999999, minArea=(long)(1.0E15), sumArea=0;
    double maxAspect=-999999, minAspect=999999999, sumAspect=0;
    int sumTerminalNumber=0;
    int maxTerminalPerCellNumber=-999999, minTerminalPerCellNumber=999999999;
    int maxTerminalPerSilkNumber=-999999, minTerminalPerSilkNumber=999999999;
    double maxTerminalDriverInOhm=-999999, minTerminalDriverInOhm=999999.9E9, sumTerminalDriverInOhm=0.0;
    int sumOTermNumber=0;
    double maxTerminalLoadInPico=-999999, minTerminalLoadInPico=999999.9E9, sumTerminalLoadInPico=0.0;
    int sumITermNumber=0;
    int chainSilkNumberPerChainMax=0, chainSilkNumberPerChainMin=9999999; long chainSilkNumberSum=0;
    int chainLengthMax=0, chainLengthMin=9999999; long chainLengthSum=0;
    for (int c=1; c<=CellNumber; c++) {
      //cell size
      if (CellSizeOriginal[c][0]>maxSize) maxSize=CellSizeOriginal[c][0];
      else if (CellSizeOriginal[c][0]<minSize) minSize=CellSizeOriginal[c][0];
      if (CellSizeOriginal[c][1]>maxSize) maxSize=CellSizeOriginal[c][1];
      else if (CellSizeOriginal[c][1]<minSize) minSize=CellSizeOriginal[c][1];
      sumSize+=(long)((CellSizeOriginal[c][0]+CellSizeOriginal[c][1])/2);
      //cell aspect ratio
      double aspect=((double)(CellSizeOriginal[c][0]))/((double)(CellSizeOriginal[c][1]));
      if (aspect<1.0) aspect=1.0/aspect;
      if (aspect>maxAspect) maxAspect=aspect;
      else if (aspect<minAspect) minAspect=aspect;
      sumAspect+=aspect;
      //cell area
      long area=((long)CellSizeOriginal[c][0])*((int)CellSizeOriginal[c][1]);
      // System.out.println("# " + CellName[c] + " area=" + area);
      if (area>maxArea) maxArea=area; 
      else if (area<minArea) minArea=area;
      sumArea+=area;
      //terminal number
      if (TerminalNumber[c]>maxTerminalPerCellNumber) maxTerminalPerCellNumber=TerminalNumber[c];
      else if (TerminalNumber[c]<minTerminalPerCellNumber) minTerminalPerCellNumber=TerminalNumber[c];
      sumTerminalNumber+=TerminalNumber[c];
      //load and driver
      for (int t=1; t<=TerminalNumber[c]; t++) {
      	if (TerminalDirection[c][t]=='i') {
      	  double load=(TerminalLoad[c][t]*PicoPerMicron/1000);
      	  if (load>maxTerminalLoadInPico) maxTerminalLoadInPico=load;
      	  if (load<minTerminalLoadInPico) minTerminalLoadInPico=load;
      	  sumTerminalLoadInPico+=load;
      	  sumITermNumber++;
        }
        else if (TerminalDirection[c][t]=='o') {
      	  double driver=(TerminalDriver[c][t]*OhmPerMicron/1000);
      	  if (driver>maxTerminalDriverInOhm) maxTerminalDriverInOhm=driver;
      	  if (driver<minTerminalDriverInOhm) minTerminalDriverInOhm=driver;
      	  sumTerminalDriverInOhm+=driver;
      	  sumOTermNumber++;
        }
      }
    }
    for (int s=1; s<=SilkNumber; s++) {
      if (SilkTerminalNumber[s]>maxTerminalPerSilkNumber) maxTerminalPerSilkNumber=SilkTerminalNumber[s];
      else if (SilkTerminalNumber[s]<minTerminalPerSilkNumber) minTerminalPerSilkNumber=SilkTerminalNumber[s];
    }    
    for (int n=1; n<=ChainNumber; n++) {
      chainSilkNumberSum+=ChainSilkNumber[n];
      if (ChainSilkNumber[n]>chainSilkNumberPerChainMax) chainSilkNumberPerChainMax=ChainSilkNumber[n];
      if (ChainSilkNumber[n]<chainSilkNumberPerChainMin) chainSilkNumberPerChainMin=ChainSilkNumber[n];
    }
    System.out.println("#############################################################################");
    System.out.println("#                              STATISTIC                                    #");
    System.out.println("#############################################################################");
    System.out.println("# Interconnect R(ohm/um)   " + OhmPerMicron);
    System.out.println("# Interconnect C(pico/um)  " + PicoPerMicron);
    System.out.println("# TimeConstant tai(ns)     " + TimeConstantInNano);
    System.out.println("# Boundary number          " + "1");
    System.out.println("# PAD number               " + TerminalNumber[0]);
    System.out.println("# Boundary number          " + "1");
    System.out.println("# Cell number              " + CellNumber);
    System.out.println("#  max/min/ave size (um)   " + maxSize/1000 + "/" + minSize/1000 + "/" + sumSize/CellNumber/1000);
    System.out.println("#  max/min/ave asp         " + ((int)(maxAspect*100)) + "%/" + ((int)(minAspect*100)) + "%/" + ((int)(sumAspect*100/CellNumber)) + "%");
    System.out.println("#  max/min/ave area (um2)  " + maxArea/1000000 + "/" + minArea/1000000 + "/" + sumArea/CellNumber/1000000);
    System.out.println("#  total cell area (um2)   " + sumArea/1000000);
    System.out.println("# Terminal Number          " + sumTerminalNumber);
    System.out.println("#  max/min/ave t-c         " + maxTerminalPerCellNumber + "/" + minTerminalPerCellNumber + "/" + (((float)sumTerminalNumber)/CellNumber));
    System.out.println("#  max/min/ave driver(ohm) " + maxTerminalDriverInOhm + "/" + minTerminalDriverInOhm + "/" + (((float)sumTerminalDriverInOhm)/sumOTermNumber));
    System.out.println("#  max/min/ave load (pico) " + maxTerminalLoadInPico + "/" + minTerminalLoadInPico + "/" + (((float)sumTerminalLoadInPico)/sumITermNumber));
    System.out.println("# Silk Number              " + SilkNumber);
    System.out.println("#  max/min/ave t-s         " + maxTerminalPerSilkNumber + "/" + minTerminalPerSilkNumber + "/" + (((float)sumTerminalNumber)/SilkNumber));
    System.out.println("# Chain number             " + ChainNumber);
    System.out.println("# ChainSilk number         " + chainSilkNumberSum);
    System.out.println("#  max/min/ave             " + chainSilkNumberPerChainMax + "/" + chainSilkNumberPerChainMin + "/" + ((float)chainSilkNumberSum)/ChainNumber);
    System.out.println("#############################################################################");
    System.out.println("#                              RESULTS                                      #");
    System.out.println("#############################################################################");
    long chipArea=((long)CellSize[0][0])*((long)CellSize[0][1]);
    System.out.println("# Chip Area (um2)          " + (chipArea/1000000));
    System.out.println("# Chip Utilization         " + (int)(((double)sumArea)/((double)chipArea)*100) + "%");
  }

  void ReportTiming() {
    System.out.println("#############################################################################");
    System.out.println("#                            TIMING REPORT                                  #");
    System.out.println("#############################################################################");
    for (int n=1; n<=ChainNumber; n++) {
      String chainSilkList=new String(); String chainSilkEnergyDelayList=new String(); 
      String chainEnergyDelayList=new String(); String chainRequiredEnergyDelayList=new String();
      for (int s=1; s<=ChainSilkNumber[n]; s++) {
        chainSilkList+=("" + SilkName[TerminalSilk[ChainSilkStartCell[n][s]][ChainSilkStartTerminal[n][s]]] + " ");
        chainSilkEnergyDelayList+=("" + ChainSilkEnergy[n][s] + "/" + (ChainSilkEnergy[n][s]*TimeConstantInNano/1000.0) + " ");
      }
      chainEnergyDelayList=("" + ChainEnergy[n] + "/" + (ChainEnergy[n]*TimeConstantInNano/1000.0));
      chainRequiredEnergyDelayList=("" + ChainRequiredEnergy[n] + "/" + (ChainRequiredEnergy[n]*TimeConstantInNano/1000.0));
      System.out.println("# Chain                    " + ChainName[n] + ": " + chainSilkList);
      System.out.println("#  silk energy/delay(ns)   " + chainSilkEnergyDelayList);
      System.out.println("#  chain energy/delay(ns)  " + chainEnergyDelayList);
      System.out.println("#  req-ed energy/delay(ns) " + chainRequiredEnergyDelayList);
      System.out.println("#  satisfied               " + ((ChainEnergy[n]<=ChainRequiredEnergy[n])?'y':'n'));
    }
  }

  long ReportTime() {
    long newTime=System.currentTimeMillis();
    long elapse=newTime-CurrentTime;
    long totalseconds=elapse;
    long hours=elapse/(1000*60*60);
    elapse-=hours*(1000*60*60);
    long minutes=elapse/(60*1000);
    elapse-=minutes*(60*1000);
    long seconds=elapse/1000;
    System.out.println("Time Elapse is " + hours + " hour " + minutes + " minute " + seconds + " second.");
    CurrentTime=newTime;
    return totalseconds;
  }

  void ReportLayout() {
    System.out.println("#############################################################################");
    System.out.println("#                            LAYOUT REPORT                                  #");
    System.out.println("#############################################################################");
    ChipArea=((long)CellSize[0][0])*((long)CellSize[0][1]);
    TotalWireLength=0;
    for (int s=1; s<=SilkNumber; s++) {
      int lbx=999999999, lby=999999999, rtx=-999999999, rty=-999999999;
      for (int tt=1; tt<=SilkTerminalNumber[s]; tt++) {
      	int c=SilkTerminalCell[s][tt], t=SilkTerminalTerminal[s][tt];
      	int tx=CellPosition[c][0]+TerminalOffset[c][t][0], ty=CellPosition[c][1]+TerminalOffset[c][t][1];
      	if (tx<lbx) lbx=tx;
      	if (ty<lby) lby=ty;
      	if (tx>rtx) rtx=tx;
      	if (ty>rty) rty=ty;
      }
      TotalWireLength+=(long)((rty-lby)+(rtx-lbx));  //half-perimeter metric
    }
    System.out.println("# Area=" + ChipArea);
    System.out.println("# Total Wire Length=" + TotalWireLength);
  }

  //misallaneous
  int GetCellIndex(String cellName) {
    for (int c=0; c<=CellNumber; c++) if (CellName[c].equals(cellName)) return c;
    return -1;
  }

  int GetTerminalIndex(String cellName, String terminalName) {
    for (int c=0; c<=CellNumber; c++) {
      if (! CellName[c].equals(cellName)) continue;
      for (int t=1; t<=TerminalNumber[c]; t++) if (TerminalName[c][t].equals(terminalName)) return t;
    }
    return -1;
  }

  int GetTerminalIndex(int cell, String terminalName) {
    for (int t=1; t<=TerminalNumber[cell]; t++) if (TerminalName[cell][t].equals(terminalName)) return t;
    return -1;
  }

  int GetSilkIndex(String silkName) {
    for (int s=1; s<=SilkNumber; s++) if (SilkName[s].equals(silkName)) return s;
    return -1;
  }

  char WhichSideOfATerminalOnACell(int c, int t, int tolerance) {
    int tox=TerminalOffset[c][t][0], toy=TerminalOffset[c][t][1];
    int csx=CellSize[c][0], csy=CellSize[c][1];
    int leftError=java.lang.Math.abs(tox);
    int rightError=java.lang.Math.abs(tox-csx);
    int bottomError=java.lang.Math.abs(toy);
    int topError=java.lang.Math.abs(toy-csy);
    char side='x';
    if (leftError<tolerance) { side='l'; tolerance=leftError; }
    if (rightError<tolerance) { side='r'; tolerance=rightError; }
    if (bottomError<tolerance) { side='b'; tolerance=bottomError; }
    if (topError<tolerance) { side='t'; tolerance=topError; }
    return side;
  }

  int HowManyOffsetOfATerminalOnACellPerimeter(int c, int t) {
    char side=WhichSideOfATerminalOnACell(c,t,1000);
    int offset=0;
    switch (side) {
      case 'b' : offset=TerminalOffset[c][t][0]; break;
      case 'r' : offset=TerminalOffset[c][t][1]+CellSize[c][0]; break;
      case 't' : offset=-TerminalOffset[c][t][0]+2*CellSize[c][0]+CellSize[c][1]; break;
      case 'l' : offset=-TerminalOffset[c][t][1]+2*(CellSize[c][0]+CellSize[c][1]); break;
      default  : System.out.println("ERROR. Cannot determine which side of terminal " + CellName[c] + "/" + TerminalName[c][t] + "!"); Sleep();
    }
    return offset;
  }

  void HowManyChainFailed() {
    int num=0;
    for (int n=1; n<=ChainNumber; n++) if (ChainEnergy[n]>ChainRequiredEnergy[n]) num++;
    FailedChainNumber=num;
    System.out.println("%REPORT failed chain number=" + FailedChainNumber);
  }

  void WhatIsMaximumChainEnergy() {
    double energy=0.0;
    for (int n=1; n<=ChainNumber; n++) if (ChainEnergy[n]>energy) energy=ChainEnergy[n];
    MaximumChainEnergy=energy;
    System.out.println("%REPORT the maximum chain energy/delay(ns)=" + MaximumChainEnergy + "/" + (MaximumChainEnergy*TimeConstantInNano/1000.0));
  }




//////////////////
//END OF CLASS
}
