import java.io.File;
import java.awt.*;
import java.applet.*;
import BioComponents.*;
import BioMechanics.*;

public class XRayApplet extends Applet {

  BioComponents m;
  int age = -1;
  int agemin, agemax;
  TextField Tagenow;
  boolean DisplaySilk=false, DisplayForce=false;

 //Set up an Organism.
  public void init() {
    File f;
    Dimension WindowSize;
    WindowSize = size();

    m = new BioComponents();
    m.Educate();
    age = 0;
    do {
      age ++;
      f = new File(m.AgeFilePrefix + age + ".org"); 
    }
    while (f.exists());
    agemin = 1; agemax = age - 1;
    Button Bagemin = new Button("" + agemin); add (Bagemin);
    Button Bagelow = new Button("<"); add (Bagelow); 
    Tagenow = new TextField(3); add (Tagenow);
    Button Bagego = new Button("go"); add (Bagego);
    Button Bagehigh = new Button(">"); add (Bagehigh);
    Button Bagemax = new Button("" + agemax); add (Bagemax);
    Button BDisplaySilk = new Button("N"); add (BDisplaySilk);
    Button BDisplayForce = new Button("F"); add (BDisplayForce);
    age = agemin;
  }
  
  public void paint(Graphics g) {
    Dimension WindowSize = size();
    int ScaleFactor;
   //Calculate the ScaleFactor and ForceFactor
    ScaleFactor = (m.CellSize[0][0] / WindowSize.width > m.CellSize[0][1]/(WindowSize.height-20)) ? 
                  (m.CellSize[0][0] / WindowSize.width) : (m.CellSize[0][1]/(WindowSize.height-20));
    if (ScaleFactor < 1) ScaleFactor = 1; //prevent it from being zero, although unlikely happens.
    int ForceFactor = 10; ForceFactor*=ScaleFactor;
   //BED
    g.drawRect(1,1,(int)(m.CellSize[0][0]/ScaleFactor) - 1, (int)(m.CellSize[0][1]/ScaleFactor) - 1);
    g.drawString("(" + (m.CellPosition[0][0]+m.CellSize[0][0])/1000 + ","
                  + (m.CellPosition[0][1]+m.CellSize[0][1])/1000 + ")",
                 (int)(m.CellSize[0][0]/ScaleFactor) - 50, (int)(m.CellSize[0][1]/ScaleFactor) + 12);
    g.drawString("(" + m.CellPosition[0][0]/1000 + "," + m.CellPosition[0][1]/1000 + ")",
                 1, 12);
   //AGE
    g.setColor(Color.darkGray);
    g.drawString("Age=" + age, 5, (int)(m.CellSize[0][1]/ScaleFactor) + 12);
   //BINS
    g.setColor(new Color(200,200,200));
    int bsx = m.CellSize[0][0]/m.BinXNumber, bsy = m.CellSize[0][1]/m.BinYNumber;
    int xEnd = (int)(m.CellSize[0][0]/ScaleFactor) - 1, yEnd = (int)(m.CellSize[0][1]/ScaleFactor) - 1;
    for (int bx = 1; bx < m.BinXNumber; bx ++) 
      g.drawLine((int)(bsx * bx / ScaleFactor), 1, (int)(bsx * bx / ScaleFactor), yEnd);
    for (int by = 1; by < m.BinYNumber; by ++) 
      g.drawLine(1, (int)(bsy * by / ScaleFactor), xEnd, (int)(bsy * by / ScaleFactor));
   //PAD DENSITY BIN
    g.setColor(Color.black); 
    double padBinSize=((double)(m.CellSize[0][0]+m.CellSize[0][1]))*2/m.PerimeterBinNumber[0];
    char boundarySide='b'; double padBinX=padBinSize, padBinY=0;
    double tmpPPP;
    for (int b=1; b<=m.PerimeterBinNumber[0]-1; b++) {
      switch (boundarySide) {
        case 'b' : g.drawLine(((int)padBinX)/ScaleFactor, ((int)padBinY)/ScaleFactor, ((int)padBinX)/ScaleFactor, ((int)padBinY)/ScaleFactor+5);
                   padBinX+=padBinSize; 
                   tmpPPP=padBinX-m.CellSize[0][0];
                   if (tmpPPP>0) { padBinY=tmpPPP; padBinX=m.CellSize[0][0]; boundarySide='r'; }
                   break;
        case 'r' : g.drawLine(((int)padBinX)/ScaleFactor, ((int)padBinY)/ScaleFactor, ((int)padBinX)/ScaleFactor-5, ((int)padBinY)/ScaleFactor);
                   padBinY+=padBinSize; 
                   tmpPPP=padBinY-m.CellSize[0][1];
                   if (tmpPPP>0) { padBinX=m.CellSize[0][0]-tmpPPP; padBinY=m.CellSize[0][1]; boundarySide='t'; }
                   break;
        case 't' : g.drawLine(((int)padBinX)/ScaleFactor, ((int)padBinY)/ScaleFactor, ((int)padBinX)/ScaleFactor, ((int)padBinY)/ScaleFactor-5);
                   padBinX-=padBinSize; 
                   tmpPPP=padBinX;
                   if (tmpPPP<0) { padBinY=m.CellSize[0][1]+tmpPPP; padBinX=0; boundarySide='l'; }
                   break;
        case 'l' : g.drawLine(((int)padBinX)/ScaleFactor, ((int)padBinY)/ScaleFactor, ((int)padBinX)/ScaleFactor+5, ((int)padBinY)/ScaleFactor);
                   padBinY-=padBinSize; 
                   break;
      }
    }
   //STEINER POINT position (used here and thereafter), force
    int steinerP[][]; steinerP = new int[m.SilkNumber+1][2];
    for (int s=1; s<=m.SilkNumber; s++) {
      steinerP[s][0] = (int)((m.SteinerPosition[s][0]-m.CellPosition[0][0])/ScaleFactor);
      steinerP[s][1] = (int)((m.SteinerPosition[s][1]-m.CellPosition[0][1])/ScaleFactor);
      //System.out.println("SteinerPoint " + m.SilkName[s] + " on screen " + steinerP[s][0] + " " + steinerP[s][1]);
      //steinerforce
      g.setColor(Color.green);
      g.fillRect(steinerP[s][0]-1, steinerP[s][1]-1, 3, 3);
      if (DisplayForce) {
        g.setColor(Color.red);
        g.drawLine(steinerP[s][0], steinerP[s][1], steinerP[s][0]+m.SteinerAttractForce[s][0]/ForceFactor, 
                                                   steinerP[s][1]+m.SteinerAttractForce[s][1]/ForceFactor);
      }
    }
   //PAD, FORCE
    int padWidth=m.PadWidthDefault/ScaleFactor, padWidthHalf=padWidth/2;
    for (int t=1; t<=m.TerminalNumber[0]; t++) {
      int tx = m.TerminalOffset[0][t][0]/ScaleFactor;
      int ty = m.TerminalOffset[0][t][1]/ScaleFactor;
      int leftError=java.lang.Math.abs(m.TerminalOffset[0][t][0]);
      int rightError=java.lang.Math.abs(m.TerminalOffset[0][t][0]-m.CellSize[0][0]);
      int bottomError=java.lang.Math.abs(m.TerminalOffset[0][t][1]);
      int topError=java.lang.Math.abs(m.TerminalOffset[0][t][1]-m.CellSize[0][1]);
      char side='x'; int minError=2000;
      if (leftError<minError) { side='l'; minError=leftError; }
      if (rightError<minError) { side='r'; minError=rightError; }
      if (bottomError<minError) { side='b'; minError=bottomError; }
      if (topError<minError) { side='t'; minError=topError; }
      g.setColor(Color.pink);
      switch (side) {
        case 'b' : g.drawRect(tx-padWidthHalf, ty-2, padWidth, 4); break;
        case 'r' : g.drawRect(tx-2, ty-padWidthHalf, 4, padWidth); break;
        case 't' : g.drawRect(tx-padWidthHalf, ty-2, padWidth, 4); break;
        case 'l' : g.drawRect(tx-2, ty-padWidthHalf, 4, padWidth); break;
        default  : System.out.println("ERROR. Cannot determine which side tha pad is " + m.TerminalName[0][t] + "!"); m.Sleep();
      }
      if (DisplaySilk) {
        g.setColor(Color.blue);
        g.drawLine(tx, ty, steinerP[m.TerminalSilk[0][t]][0], steinerP[m.TerminalSilk[0][t]][1]);
      }
      if (DisplayForce) {
        g.setColor(Color.green);
        switch (side) {
          case 'b' : g.drawLine(tx, ty, tx+m.Terminal1DFillingForce[0][t]/ForceFactor, ty+1); break;
          case 'r' : g.drawLine(tx, ty, tx-1, ty+m.Terminal1DFillingForce[0][t]/ForceFactor); break;
          case 't' : g.drawLine(tx, ty, tx-m.Terminal1DFillingForce[0][t]/ForceFactor, ty-1); break;
          case 'l' : g.drawLine(tx, ty, tx+1, ty-m.Terminal1DFillingForce[0][t]/ForceFactor); break;
        }
        g.setColor(Color.cyan);
        switch (side) {
          case 'b' : g.drawLine(tx, ty, tx+m.Terminal1DForce[0][t]/ForceFactor, ty+2); break;
          case 'r' : g.drawLine(tx, ty, tx-2, ty+m.Terminal1DForce[0][t]/ForceFactor); break;
          case 't' : g.drawLine(tx, ty, tx-m.Terminal1DForce[0][t]/ForceFactor, ty-2); break;
          case 'l' : g.drawLine(tx, ty, tx+2, ty-m.Terminal1DForce[0][t]/ForceFactor); break;
        }
      }
    }
   //CELL, SILK, FORCE of MacroCells
    for (int c=1; c<=m.CellNumber; c++) {
      //CELL
      int cx=m.CellPosition[c][0]-m.CellPosition[0][0], cy=m.CellPosition[c][1]-m.CellPosition[0][1]; //compensate bed position
      g.setColor(Color.red);
      g.drawRect(cx/ScaleFactor, cy/ScaleFactor, m.CellSize[c][0]/ScaleFactor, m.CellSize[c][1]/ScaleFactor);
      g.drawString(m.CellName[c], cx/ScaleFactor, (cy+m.CellSize[c][1])/ScaleFactor);
      //KEEPOUT THICKNESS
      g.setColor(Color.red);
      g.drawRect((cx-m.CellKeepOutThickness[c][0])/ScaleFactor, (cy-m.CellKeepOutThickness[c][1])/ScaleFactor,
                 (m.CellSize[c][0]+m.CellKeepOutThickness[c][0]+m.CellKeepOutThickness[c][2])/ScaleFactor,
                 (m.CellSize[c][1]+m.CellKeepOutThickness[c][1]+m.CellKeepOutThickness[c][3])/ScaleFactor);
      //SILK
      if (DisplaySilk) {
        g.setColor(Color.blue);
        for (int t=1; t<=m.TerminalNumber[c]; t++) {
          int tx = (cx+m.TerminalOffset[c][t][0])/ScaleFactor;
          int ty = (cy+m.TerminalOffset[c][t][1])/ScaleFactor; 
          g.drawRect(tx-1, ty-1, 3, 3);
          g.drawLine(tx, ty, steinerP[m.TerminalSilk[c][t]][0], steinerP[m.TerminalSilk[c][t]][1]);
        }
      }
      if (DisplayForce) {
       //ATTRACT FORCE
        int ccx=(cx+m.CellSize[c][0]/2)/ScaleFactor, ccy=(cy+m.CellSize[c][1]/2)/ScaleFactor; //cell center for drawing.
        g.setColor(Color.red);
        g.drawLine(ccx, ccy, ccx+m.CellAttractForce[c][0]/ForceFactor, ccy+m.CellAttractForce[c][1]/ForceFactor);
       //REPULSE FORCE
        g.setColor(Color.magenta);
       //FILLING FORCE
        g.setColor(Color.green);
        g.drawLine(ccx, ccy, ccx+m.CellFillingForce[c][0]/ForceFactor, ccy+m.CellFillingForce[c][1]/ForceFactor);
      }       
    }

   //OVER   
  }

  public boolean action(Event evt, Object arg) {
    if (arg instanceof String) {
      if (arg.equals("" + agemin)) {
        age = agemin;
        Tagenow.setText("" + age);
        m.Read(age);
        repaint();
        return true;
      }
      else if (arg.equals("<") & (age>agemin)) {
        age --;
        Tagenow.setText("" + age);
        m.Read(age);
        repaint();
        return true;
      }
      else if (arg.equals(">") & (age<agemax)) {
        age ++;
        Tagenow.setText("" + age);
        m.Read(age);
        repaint();
        return true;
      }
      else if (arg.equals("" + agemax)) {
        age = agemax;
        Tagenow.setText("" + age);
        m.Read(age);
        repaint();
        return true;
      }
      else if (arg.equals("go")) {
        int agetmp;
        agetmp = Integer.parseInt(Tagenow.getText());
        //if ((agetmp >= agemin) & (agetmp <= agemax)) age = agetmp;
        age=agetmp;
        m.Read(age);
        repaint();
        return true;
      }
      else if (arg.equals("N")) {
        DisplaySilk = !DisplaySilk;
        repaint();
        return true;
      }
      else if (arg.equals("F")) {
        DisplayForce = !DisplayForce;
        repaint();
        return true;
      }
    }
    return false;
  }

}
